<template>
  <v-container>
    <v-dialog v-model="dialog" persistent max-width="50%">
      <v-card>
        <v-card-title>
          <span v-text="title" />
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="4" v-if="isEdit">
                <v-text-field label="ID*" v-model="form_app.id" required readonly v-if="isEdit"  :error-messages="error_payload.id" @input="setResetError" @blur="setResetError" />
              </v-col>
              <v-col cols="4">
                <v-select
                    v-model="form_app.form_type"
                    :items="clients"
                    label="Form Type*"
                    :disabled="statusProgress"
                    :error-messages="error_payload.form_type"
                    @change="setResetError"
                    @blur="setResetError"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4">
                <v-text-field label="Name*" v-model="form_app.name" :disabled="statusProgress" required :error-messages="error_payload.name" @input="setResetError" @blur="setResetError" />
              </v-col>
              <v-col cols="6">
                <v-text-field label="Form Path*" v-model="form_app.form" :disabled="statusProgress" required :error-messages="error_payload.form" @input="setResetError" @blur="setResetError" />
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
          <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
          <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
        </v-card-actions>
      </v-card>
      <DlgMsg ref="dlgMsg" />
      <Loading ref="loading" :dlg-loading="statusProgress" />
    </v-dialog>
  </v-container>
</template>

<script>
import DlgMsg from "./dialog/DlgMsg";
import Loading from "./dialog/Loading";

import {checkError400, checkError404} from "../utils/util";
import formAppService from "../service/FormAppService";
import menuServices from "../service/MenuService";

export default {
  name: "FormAppForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      clients: [],
      form_app: {
        id: null,
        form_type: null,
        name: null,
        form: null,
      },
      error_payload: {
        id: [],
        form_type: [],
        name: [],
        form: [],
      },
      title: null,
      dialog: false,
      isEdit: false,
      statusProgress: false,
    }
  },
  methods: {
    doClose() {
      this.dialog = false
    },
    async doAdd(title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.doReset()
      this.statusProgress = true
      this.doLoadClientId()
      this.statusProgress = false
    },
    doEdit(dataPk, title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.statusProgress = true
      this.doLoadClientId()
      this.retrieveForm(dataPk)
    },
    async retrieveForm(dataPk) {
      await formAppService.getByIdAndType(dataPk.id, dataPk.form_type).then(resp => {
        let {data, message, status} = resp.data
        if (status === 'SUCCESS') {
          this.form_app = data
        } else {
          this.$refs.dlgMsg(message)
        }
      }).catch(ex => {
        checkError404(ex, this.$refs.dlgMsg)
      })
      this.statusProgress = false
    },
    doReset() {
      if (!this.isEdit)
        this.form_app.id = '0'
      this.form_app.form_type = null
      this.form_app.name = null
      this.form_app.form = null

      this.isParentOnly = false
      this.isChildOnly = false
      this.isComponentOnly = false

      this.setResetError()
    },
    setResetError() {
      this.error_payload.id = []
      this.error_payload.form_type = []
      this.error_payload.name = []
      this.error_payload.form = []
    },
    async doSaveOrUpdate() {
      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(this.form_app)
      } else {
        await this.doUpdate(this.form_app)
      }
      this.statusProgress = false
    },
    async doSave(data) {
      formAppService.store(data).then(async resp => {
        let {message, status} = resp.data
        if (status === 'SUCCESS') {
          await this.$parent.doRefresh()
          this.doReset()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        checkError400(ex, this.$refs.dlgMsg, this.error_payload)
      })
    },
    async doUpdate(data) {
      formAppService.update(data).then(async resp => {
        let {message, status} = resp.data
        if (status === 'SUCCESS') {
          await this.$parent.doRefresh()
          this.doClose()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        checkError400(ex, this.$refs.dlgMsg, this.error_payload)
      })
    },
    async doLoadClientId() {
      await menuServices.getClientId().then(resp => {
        let {data, message, status} = resp.data
        if (status === 'SUCCESS') {
          this.clients = data
        } else {
          this.$refs.dlgMsg.doOpenMsg(message)
        }
      }).catch(ex => {
        checkError404(ex,this.$refs.dlgMsg)
      })
    },
  },
}

</script>

<style scoped>

</style>